#ifndef MOVINGEUCLIDEAN_H
#define MOVINGEUCLIDEAN_H


#include "timeseries.h"
#include "timeseriescollection.h"
#include <vector>


#define VARIANT_MOVINGAVG 1
#define VARIANT_EXPMOVINGAVG 2
#define VARIANT_P_MOVINGAVG 3
#define VARIANT_P_EXPMOVINGAVG 4


class MovingEuclidean
{
public:
    MovingEuclidean(TimeSeriesCollection &collection, int variant);
    vector<int> rangeQuery(TimeSeries &ts, double threshold);
    double distance(TimeSeries &ts1, TimeSeries &ts2);
double movingAverage(TimeSeries &ts, int pos, int n);

void writeToFile(int id, const char *pathname);

    TimeSeriesCollection collection;
    vector<double> distances;
    int variant;

    int w;
    double l;

};

#endif // MOVINGEUCLIDEAN_H
