/*
 * QueryEngine.h
 *
 *  Created on: Apr 14, 2011
 *      Author: besa
 */

#ifndef QUERYENGINE_H_
#define QUERYENGINE_H_
#include "Approximator.h"
#include <string>
#include <vector>


class QueryEngine {
public:
	typedef struct PrTimeResults
	{
		double Precision;
		double Recall;
		double F1;
		double Time;
	};
	typedef std::pair<string, double> tuple;

	QueryEngine();
	QueryEngine(double e, int t);
	QueryEngine(double e, double t, int q_ind);
	virtual ~QueryEngine();

	string RESULT_PATH;
	Approximator approximator;
	double epsilon;
	double tao;
	int topk;
	int query_index;
	vector<tuple> results;
	PrTimeResults finalResults;
	vector< vector<int> > euclidean_matrix;

	void queryNaive();
	PrTimeResults queryPBRQ();
	void queryPRRQ();
	string getNext();
	bool getNextCombination(int current[], int size, int samples);
	double euclidean(double t1[], double t2[], int size1, int size2);
	void print();
	void write_to_file(string filename);
	void precision_recall();
private:
	struct sort_pred {
		bool operator() (const tuple& left, const tuple& right)
		{
			return left.second > right.second;
		}
	};

};

#endif /* QUERYENGINE_H_ */
